import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Animator extends JComponent /*<b>*/ implements ActionListener //</b>
{					//<b>
  	Timer 	timer;  //</b>

	private final int	  refresh_rate;
	private final Image[] frames;
	private		  int	  current_frame = 0;
	private		  Thread  driver;
	//------------------------------------------------------------------
	public Animator( Image[] frames, int refresh_rate )
											throws InterruptedException
	{
		this.frames 	  = frames;
		this.refresh_rate = refresh_rate;
														//<b>
	  	timer= new Timer(refresh_rate, this);
	    timer.setInitialDelay(0);
	    timer.setCoalesce(true);						//</b>

		MediaTracker tracker = new MediaTracker(this);	// wait for all
		for( int i = 0; i < frames.length; ++i )		// images to 
			tracker.addImage( frames[i], 0 );			// load
		tracker.waitForAll();
	}
	//------------------------------------------------------------------
	public void start() //<b>
	{	timer.start();	//</b>
	}
	//------------------------------------------------------------------
	public void stop()		//<b>
	{	timer.stop();		//</b>
	}
	//------------------------------------------------------------------
	public Dimension getPreferredSize()
	{	return new Dimension(	frames[0].getWidth(this),
								frames[0].getHeight(this) );
	}
	//------------------------------------------------------------------
	public void paint( Graphics g )
	{	g.drawImage( frames[ current_frame ], 0, 0,
						getBounds().width, getBounds().height, this );
	}
	//------------------------------------------------------------------
 	public void actionPerformed( ActionEvent e )
	{	++current_frame;
		current_frame %= frames.length;
		repaint();
	}
	//==================================================================
	public static class Test extends JFrame
	{
		static public void main( String[] s ) throws Exception
		{
			Toolkit	kit		= Toolkit.getDefaultToolkit();
			Image[] images	= new Image[]
			{
				kit.getImage("5.images/Juggler0.gif"),
				kit.getImage("5.images/Juggler1.gif"),
				kit.getImage("5.images/Juggler2.gif"),
				kit.getImage("5.images/Juggler3.gif"),
				kit.getImage("5.images/Juggler4.gif") 
			};

			Animator animator = new Animator( images, 100 );

			JFrame frame = new Test();
			frame.getContentPane().add( animator );
			frame.pack();
			frame.show();

			animator.start();
			Thread.currentThread().sleep( 5 * 1000 );
			animator.stop();
			System.exit(0);
		}
	}
}
